// AbstractOscDemo stub
int SCREEN_WIDTH = 700;
int SCREEN_HEIGHT = 700;

Point lastPoint, nextPoint;

int iterationCount = 0;
// Point oldPoint, newPoint;

void setup() {
  background(255);
  size(SCREEN_WIDTH, SCREEN_HEIGHT);
  
  setupOsc();
  prep();
}

int offset_1 = 10;
int coef_1 = 700;
int flash_clear_mod = 37;
int strokeWeight = 3;
int strokeWeightMod = 5;
int erodeMod = 4;
int whiteErodeLoopNum = 3;

int baseColorRange = 200;

float minLineNoiseDist = 100.0; // We get overflow errors later on if this is below 3.0

int topColorRange = 255;
int colorFocus = 1;
int[] strokeColors = {100,100,100};


void straightLine( Point p1, Point p2) {
  //  line(p1.x(), p1.y(), p2.x(), p2.y() );
  float d = dist(p1.x(), p1.y(), p2.x(), p2.y() );
  ellipse(p2.x(), p2.y() , d, d);
}

void noiseyLine(Point p1, Point p2) {
  // We want to a line from p1 to p2
  // We want to do it all kinda wiggly
  // So: check the length of the line.
  // if less then some delta then just draw the line
  // Else, split the line in two (i.e. get the midpoint) at some random point 
  // between half the length of the line and delta.
  // We now have three points.  Make p2new noisey.
  // Call noiseyLine( p1, p2new)  and  noiseyLine(p2new, p2) 
  //
  // at some point each call just returns
    noFill();
  float d = dist(p1.x(), p1.y(), p2.x(), p2.y() ); 
  if (d < minLineNoiseDist) {
         ellipse(p2.x(), p2.y() , d,d);
    // too small to split anymore
    for(int r = int(d); r > 0 ; r-= (strokeWeight+10) ){ ellipse(p2.x(), p2.y() , r, r); }
    noFill();

 //   ellipse(p2.x(), p2.y() , 0.2, 0.2);
     // busy();

    return;
  } 

  float midX = p1.x()+( (p2.x()-p1.x() )/2.0);
  float midY = p1.y()+( (p2.y()-p1.y() )/2.0);


  float xnoise = random(1, int(minLineNoiseDist/2) )+ midX ;
  float ynoise = random(1, int(minLineNoiseDist/2))+ midY ;
  Point p2new = new Point(xnoise, ynoise);

  noiseyLine(p1, p2new);
  noiseyLine(p2new, p2); 
}
void busy(){
    for (int i=0; i< 10; i++ ){ for (int ii=0; ii< 10; ii++ ){ print(""); } }
}
void draw() {
  tint(255, 16);
  frameRate = 2; // (frameRate % 10 ) + 2;
  smooth();
  topColorRange = baseColorRange + 100;
  
  if (topColorRange > 255) 
    topColorRange = 255;
  if (iterationCount % strokeWeightMod == 0 ) {
    strokeWeight = int(random(1.0, 15.0));
  }

  strokeWeight(strokeWeight);

  iterationCount  = iterationCount % 256;

  if (iterationCount % flash_clear_mod == 0 ){
     busy();
     strokeWeight(90);
    // strokeWeight(2);
    stroke(255);
    straightLine( lastPoint, nextPoint );
    for(int i=0; i < whiteErodeLoopNum; i++ ){
    filter(BLUR,2);
    filter(DILATE);
    }
  } else {
    for(int i=0; i<3; i++){
      strokeColors[i] = int(random(baseColorRange, topColorRange));
    }
    colorFocus = int(random(0,3));
    strokeColors[colorFocus] = 255;
    stroke(strokeColors[0] , strokeColors[1] , strokeColors[2] );

    noiseyLine( lastPoint, nextPoint );
  }
  iterationCount += 1;

  //line( lastPoint.x(), lastPoint.y(), nextPoint.x(), nextPoint.y() );

  lastPoint.assign(nextPoint);

  float nextX = 0.0;
  float nextY =0.0;

  // See what quadrant this is in and pick a point in thr opposite quadrant,
  // with room for error.  That is, allow for the change of point being selected in some other 
  // quadrant 
  switch (nextPoint.quadrant()){

    case 1:
      nextX =  random(width/3, width);
      nextY =  random(height/3, height);
      break;
    case 2:
      nextX =  random(0, width/3);
      nextY =  random(height/3, height);
      break;
    case 3:
      nextX =  nextX =  random(width/3, width);
      nextY =  random(0, height/3);

      break;
    case 4:
      nextX =  nextX =  random(0, width/3);
      nextY =  random(0, height/3);

      break;
  }

  nextPoint = new Point(nextX, nextY);
  random(100);
  nextPoint.setY(random(0, SCREEN_HEIGHT));
  if (iterationCount % erodeMod  == 0) {
    filter(BLUR,2);
    filter(DILATE);
  }
}


void prep(){
  iterationCount = 0;
  lastPoint = new Point(random(0, SCREEN_WIDTH), random(0, SCREEN_HEIGHT) );
  nextPoint = new Point(int(random(0, SCREEN_WIDTH)), random(0, SCREEN_HEIGHT ) );
}
