import oscP5.*;
import netP5.*;

OscP5 clientOscP5;

String configFile       = "config.txt";
String clientAddressText = "127.0.0.1";
String clientPortText = "8001";

String  serverAddressText = "127.0.0.1";
String  serverPortText = "8002";

NetAddress oscServerAddress;
NetAddress oscClientAddress;


void createOscStuff(){
  oscServerAddress = new NetAddress(serverAddressText, int(serverPortText) );
  oscClientAddress = new NetAddress(clientAddressText, int(clientPortText) );
  println("Listening on " + clientPortText );
  clientOscP5 = new OscP5(this,  int(trim(clientPortText)) );
}


void setupOsc()  {
  loadData();
  createOscStuff();
  OscMessage m = new OscMessage("/jtbp/start");
  println("\n    Send to "+ oscServerAddress.address()  +": " + oscServerAddress.port() + ": /jtbp/response " ); // DEBUG
  clientOscP5.send(m, oscServerAddress); // Need to pass the addres to send it to 

  println("Sent OK?"); // DEBUG
  //stop();
}



void loadData(){
  String defaultValues[] = split("127.0.0.1:8000\n127.0.0.1:8080\n/some/address/pattern 123, \"SOme text\" 3.1415", "\n");
  try {
    String lines[] = loadStrings(configFile);
    for (int i=0; i < lines.length; i++) { defaultValues[i] =  lines[i]; }
    int i = 0;

    String[] parts = split(defaultValues[i], ":");

    clientAddressText = trim(parts[0]);
    clientPortText = trim(parts[1]) ;   
    i++;

    parts = split(defaultValues[i], ":");

    serverAddressText = trim(parts[0]);
    serverPortText =trim(parts[1]);


  } catch(Exception e) {
    println("Error loading data from '" + configFile + "'");
    e.printStackTrace();
  }

}



